## qliveplayer-4.0.1-1.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
# SET(CMAKE_INSTALL_PREFIX /usr CACHE PATH "Set install prefix.")
project(QLivePlayer)
set(PROJECT_VERSION "4.0.1")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(ECM 1.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(ECMUninstallTarget)
find_program(MPV_PATH NAMES mpv REQUIRED)
IF(${MPV_PATH} STREQUAL MPV_PATH-NOTFOUND)
	message(FATAL_ERROR "mpv not found!!!")
ENDIF()

include(FeatureSummary)
find_package(Cargo REQUIRED)
find_package(Rust REQUIRED)
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
#find_package(OpenSSL REQUIRED)
find_package(Qt5 COMPONENTS Core Gui Widgets Network Quick Qml QuickWidgets REQUIRED)

install(FILES "icon/qliveplayer.svg"
        DESTINATION "share/icons/hicolor/scalable/apps")
install(FILES "misc/qliveplayer.desktop"
        DESTINATION "share/applications")
install(FILES "misc/qlp-mime.desktop"
        DESTINATION "share/applications")

add_subdirectory(src)

=== src/CMakeLists.txt ===
string(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)
if(CMAKE_BUILD_TYPE_UPPER STREQUAL DEBUG)
    set(RUST_TARGET_DIR target/debug/)
    set(RUST_BUILD_FLAG)
else()
    set(RUST_TARGET_DIR target/release/)
    set(RUST_BUILD_FLAG --release)
endif()

cmake_policy(SET CMP0046 NEW)
cmake_policy(SET CMP0063 NEW)
cmake_policy(SET CMP0071 NEW)
cmake_policy(SET CMP0003 NEW)
cmake_policy(SET CMP0005 NEW)

SET(RUST_DIR "${CMAKE_CURRENT_SOURCE_DIR}/QLivePlayer-Lib")
if (MSVC)
  SET(RUST_LIB "${RUST_DIR}/${RUST_TARGET_DIR}/rust.lib")
else()
  SET(RUST_LIB "${RUST_DIR}/${RUST_TARGET_DIR}/librust.a")
endif()

add_custom_command(
  OUTPUT "${RUST_LIB}"
  COMMAND ${Cargo_EXECUTABLE} build ${RUST_BUILD_FLAG}
  DEPENDS QLivePlayer-Lib/src/lib.rs
          QLivePlayer-Lib/src/implementation.rs
          QLivePlayer-Lib/src/interface.rs
  WORKING_DIRECTORY "${RUST_DIR}"
)
add_custom_target(rust_target DEPENDS "${RUST_LIB}")

set(qlp_file_SRCS
    main.cpp
    mainwindow.cpp
    room_model.cpp
    sites.cpp
    datasource.cpp
    qlpconfig.cpp
    launcher.cpp
    resource.qrc
)

add_executable(qliveplayer ${qlp_file_SRCS})
target_compile_definitions(qliveplayer PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")
target_link_libraries(qliveplayer
  Qt5::Core
  Qt5::Gui
  Qt5::Widgets
  Qt5::Quick
  Qt5::Qml
  Qt5::QuickWidgets
)

file(GLOB qlprecorder tools/qlprecorder)
install(PROGRAMS ${qlprecorder} DESTINATION bin)
install(TARGETS qliveplayer DESTINATION bin)
add_subdirectory(qlphelper)
add_subdirectory(qlpjs)

=== src/qlphelper/CMakeLists.txt ===
set(qlphelper_file_SRCS
    main.cpp
    qlphelper.cpp
    danmakulauncher.cpp
    fudujikiller.cpp
    streamer.cpp
    mpvcontrol.cpp
    ffmpegcontrol.cpp
    bilivideo.cpp
    streamfinder.cpp
    qlpcmdparser.cpp
   ../qlpconfig.cpp
   ../Binding.cpp
)

add_executable(qlphelper ${qlphelper_file_SRCS})
target_compile_definitions(qlphelper PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")
add_dependencies(qlphelper rust_target)
target_link_libraries(qlphelper
  Qt5::Core
  Qt5::Network
  Threads::Threads
  "${RUST_LIB}"
  ${CMAKE_DL_LIBS}
)

install(TARGETS qlphelper DESTINATION bin)

=== src/qlpjs/CMakeLists.txt ===
set(qlphelper_file_SRCS
    main.cpp
    jsengine.cpp
)

add_executable(qlpjs ${qlphelper_file_SRCS})
target_link_libraries(qlpjs
  Qt5::Core
  Qt5::Qml
)

target_compile_definitions(qlpjs PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")

install(TARGETS qlpjs DESTINATION bin)

=== PKGBUILD ===
# Maintainer: Felix Yan <felixonmars@archlinux.org>
# Contributor: Megumi_fox <i@megumifox.com>

pkgname=qliveplayer
pkgver=4.0.1
_libcommit=03d3c7b0bf010986710182ba4ab9a887b4c3b42d
pkgrel=1
pkgdesc='Cute and useful Live Stream Player with danmaku support.'
arch=('x86_64')
url="https://github.com/IsoaSFlus/QLivePlayer"
license=('GPL2')
depends=('ffmpeg' 'mpv' 'qt5-base' 'qt5-declarative' 'qt5-graphicaleffects' 'qt5-quickcontrols'
         'qt5-quickcontrols2' 'qt5-svg')
makedepends=('extra-cmake-modules' 'ninja' 'rust')
optdepends=('streamlink: for foreign streaming service support')
source=("https://github.com/IsoaSFlus/QLivePlayer/archive/$pkgver/$pkgname-$pkgver.tar.gz"
        "https://github.com/IsoaSFlus/QLivePlayer-Lib/archive/$_libcommit/$pkgname-lib-$_libcommit.tar.gz")
sha512sums=('f63ac6ec483355ae7cdc31296b4640af2c56f7cc1f011abb7072a7b18f588f77331e6bf0399668e7b44890a6bc6b7647d60db1124e7d0137e0aa89df5908c516'
            '4330f869d325117f59b11300c50cbf69af31173ffe9c909cb7fb8bc752c23a5a49cb402fd95097540ec091f68382c1d34aa406c3a231774d348cb339a1dc1939')

prepare() {
    mkdir -p build
    rmdir QLivePlayer-$pkgver/src/QLivePlayer-Lib
    ln -s ../../QLivePlayer-Lib-$_libcommit QLivePlayer-$pkgver/src/QLivePlayer-Lib
}

build() {
    cd build
    cmake -GNinja -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_LIBDIR=lib ../QLivePlayer-$pkgver
    ninja
}

package() {
    cd build
    DESTDIR="$pkgdir" ninja install
}
